Attribute VB_Name = "modAPI"
Option Explicit

Public Const EC_COMPLETE    As Long = 1

Public Type OPENFILENAME
    lStructSize         As Long
    hwndOwner           As Long
    hInstance           As Long
    lpstrFilter         As Long
    lpstrCustomFilter   As Long
    nMaxCustFilter      As Long
    nFilterIndex        As Long
    lpstrFile           As Long
    nMaxFile            As Long
    lpstrFileTitle      As Long
    nMaxFileTitle       As Long
    lpstrInitialDir     As Long
    lpstrTitle          As Long
    flags               As Long
    nFileOffset         As Integer
    nFileExtension      As Integer
    lpstrDefExt         As Long
    lCustData           As Long
    lpfnHook            As Long
    lpTemplateName      As Long
End Type

Public Declare Function GetOpenFileName Lib "comdlg32.dll" _
                        Alias "GetOpenFileNameW" ( _
                        ByRef pOpenfilename As OPENFILENAME) As Long
Public Declare Function GUIDFromString Lib "shell32" _
                        Alias "#704" ( _
                        ByVal psz As Long, _
                        ByRef pGuid As Any) As Long
Public Declare Function InterlockedIncrement Lib "kernel32" ( _
                        ByRef lpAddend As Long) As Long
Public Declare Function InterlockedDecrement Lib "kernel32" ( _
                        ByRef lpAddend As Long) As Long
Public Declare Function GetMem4 Lib "msvbvm60" ( _
                        ByRef pSrc As Any, _
                        ByRef pDst As Any) As Long
Public Declare Function ColorHLSToRGB Lib "shlwapi.dll" ( _
                        ByVal wHue As Integer, _
                        ByVal wLuminance As Integer, _
                        ByVal wSaturation As Integer) As Long

' // Show open file dialog and get opened file name
Public Function GetOpenFile( _
                ByVal hwnd As Long, _
                ByRef sTitle As String, _
                ByRef sFilter As String) As String
    Dim tOfn            As OPENFILENAME
    Dim strInputFile    As String
    
    With tOfn
    
        .nMaxFile = 260
        strInputFile = String$(.nMaxFile, vbNullChar)
        
        .hwndOwner = hwnd
        .lpstrTitle = StrPtr(sTitle)
        .lpstrFile = StrPtr(strInputFile)
        .lStructSize = Len(tOfn)
        .lpstrFilter = StrPtr(sFilter)
        
        If GetOpenFileName(tOfn) = 0 Then Exit Function
        
        GetOpenFile = Left$(strInputFile, InStr(1, strInputFile, vbNullChar) - 1)
        
    End With

End Function


